import React from "react";
import { Context, Mutate } from "./Context";
export declare type ProviderProps<State> = {
    state: State;
    children: React.ReactNode;
};
export declare type ProviderState<State> = {
    state: State;
};
export declare function createProvider<State>(Provider: React.Provider<State>, context: Context<State>): {
    new (props: ProviderProps<State>): {
        /**
         * render.
         */
        render(): JSX.Element;
        /**
         * state getter.
         */
        getState: () => State;
        /**
         * state updator.
         */
        updateState: (mutator: Mutate<State>) => void;
        setState<K extends "state">(state: ProviderState<State> | ((prevState: Readonly<ProviderState<State>>, props: Readonly<ProviderProps<State>>) => ProviderState<State> | Pick<ProviderState<State>, K> | null) | Pick<ProviderState<State>, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callBack?: (() => void) | undefined): void;
        readonly props: Readonly<{
            children?: React.ReactNode;
        }> & Readonly<ProviderProps<State>>;
        state: Readonly<ProviderState<State>>;
        context: any;
        refs: {
            [key: string]: React.ReactInstance;
        };
    };
};
