"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var immer_1 = require("immer");
function createProvider(Provider, context) {
    /**
     * SrimmerProvider.
     */
    return /** @class */ (function (_super) {
        tslib_1.__extends(SrimmerProvider, _super);
        /**
         * props to state.
         */
        function SrimmerProvider(props) {
            var _this = _super.call(this, props) || this;
            /**
             * state getter.
             */
            _this.getState = function () {
                return _this.state.state;
            };
            /**
             * state updator.
             */
            _this.updateState = function (mutator) {
                _this.setState({
                    state: immer_1.produce(_this.state.state, function () {
                        mutator(this);
                    })
                });
            };
            _this.state = { state: props.state };
            context.getState = _this.getState;
            context.updateState = _this.updateState;
            return _this;
        }
        /**
         * render.
         */
        SrimmerProvider.prototype.render = function () {
            return (react_1.default.createElement(Provider, { value: this.state.state }, this.props.children));
        };
        return SrimmerProvider;
    }(react_1.default.Component));
}
exports.createProvider = createProvider;
//# sourceMappingURL=Provider.js.map