"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var Context_1 = require("./Context");
var Consumer_1 = require("./Consumer");
var Provider_1 = require("./Provider");
function define() {
    var context = new Context_1.Context();
    var _a = react_1.default.createContext({}, function (_, next) { return context.calculateBitmask(next); }), Provider = _a.Provider, Consumer = _a.Consumer;
    var SrimmerProvider = Provider_1.createProvider(Provider, context);
    var SrimmerConsumer = Consumer_1.createConsumer(Consumer, context);
    return {
        Provider: SrimmerProvider,
        Consumer: SrimmerConsumer,
        get: function () {
            return context.getState ? context.getState() : null;
        },
        update: function (mutator) {
            if (context.updateState) {
                context.updateState(mutator);
            }
        },
        create: function create(select) {
            return function (props) { return (react_1.default.createElement(SrimmerConsumer, { select: select }, props.children)); };
        }
    };
}
exports.define = define;
//# sourceMappingURL=index.js.map