/**
 * Mutate function.
 */
export declare type Mutate<State> = (state: State) => void;
/**
 * Select function.
 */
export declare type Select<State, T = any> = (state: State) => T;
/**
 * bit's state.
 */
export declare type BitState = {
    bit: number;
    state?: any;
};
/**
 * Context.
 */
export declare class Context<State> {
    /**
     * get state function(Provider#getState).
     */
    getState?: () => State;
    /**
     * update state function(Provider#updateState).
     */
    updateState?: (mutate: Mutate<State>) => void;
    /**
     * Consumer's select props as bitmask.
     */
    private bitmask;
    /**
     * calculate bitmask.
     */
    calculateBitmask(nextState: State): number;
    /**
     * register select function.
     */
    register(select: Select<State>): void;
    /**
     * getBitState.
     */
    getBitState(select: (state: State) => any): BitState;
}
